/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeVersion;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_PreCathAnginaType;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_PreCathAnginaType;


/**
 * This class represents PreCathAnginaType - CID3738
 */
public class PreCathAnginaType_CID3738 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The Coding Scheme Version
	 */
	private String strCodingSchemeVersion = null;

	/**
	 * Instantiates a new PreCathAnginaType_CID3738 Template.
	 */
	public PreCathAnginaType_CID3738() 
	{

	}

	/**
	 * Retrieves the value for CodeMeaning
	 * @return strCodeMeaning String value for CodeMeaning
	 */
	public String getCodeMeaning() 
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for CodeValue
	 * @return strCodeValue String value for CodeValue
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for CodingSchemeDesignator
	 * @return strCodingSchemeDesignator String value for CodingSchemeDesignator
	 */
	public String getCodingSchemeDesignator()
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Retrieves the value for CodingSchemeVersion
	 * @return
	 */
	public String getCodingSchemeVersion() {
		return strCodingSchemeVersion;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumPreCathAnginaType Object of EnumCM_PreCathAnginaType represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_PreCathAnginaType enumPreCathAnginaType)
	{
		switch(enumPreCathAnginaType)
		{
		case ACUTE_CORONARY_SYNDROME_NON_ST_ELEVATION_MYOCARDIAL_INFARCTION:
			this.strCodeValue = EnumCV_PreCathAnginaType.ACUTE_CORONARY_SYNDROME_NON_ST_ELEVATION_MYOCARDIAL_INFARCTION_49_IIIb.getValue();
			break;
		case ACUTE_CORONARY_SYNDROME_ST_ELEVATION_MYOCARDIAL_INFARCTION:
			this.strCodeValue = EnumCV_PreCathAnginaType.ACUTE_CORONARY_SYNDROME_ST_ELEVATION_MYOCARDIAL_INFARCTION_49_IIIc.getValue();
			break;
		case ACUTE_CORONARY_SYNDROME_UNSTABLE_ANGINA:
			this.strCodeValue = EnumCV_PreCathAnginaType.ACUTE_CORONARY_SYNDROME_UNSTABLE_ANGINA_49_IIIa.getValue();
			break;
		case ATYPICAL_CHEST_PAIN:
			this.strCodeValue = EnumCV_PreCathAnginaType.ATYPICAL_CHEST_PAIN_49_I.getValue();
			break;
		case STABLE_ANGINA:
			this.strCodeValue = EnumCV_PreCathAnginaType.STABLE_ANGINA_49_II.getValue();
			break;
		}
	}

	/**
	 * Sets the value for PreCathAnginaType
	 * @param enumPreCathAnginaType Enum for PreCathAnginaType
	 */
	public void setPreCathAnginaType(EnumCM_PreCathAnginaType enumPreCathAnginaType)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumPreCathAnginaType.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.NCDR.getValue();
		this.strCodingSchemeVersion = EnumCodingSchemeVersion.CSV_2_0b.getValue();
			
		/**
		 * set code Value
		 */
		setCodeValue(enumPreCathAnginaType);
	}
}
